#line 1 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/Programme/Eigene Programme II/USB/USB_PIC32 - II/MSC_Storage.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/include/stdint.h"




typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 4 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/Programme/Eigene Programme II/USB/USB_PIC32 - II/MSC_Storage.c"
static const uint8_t MODE_SENSE_6_DATA[8] = {
 0x00,
 0x00,
 0x00,
 0x00,
 0x00,
 0x00,
 0x00,
 0x00
};



static const uint8_t STD_INQUIRY_DATA[36] = {
 0x00,
 0x80,
 0x00,
 0x02,
 0x1F,
 0x00,
 0x00,
 0x00,
 'M', 'I', 'K', 'R', 'O', 'E', ' ', ' ',
 'm', 'i', 'c', 'r', 'o', 'S', 'D', ' ',
 'F', 'l', 'a', 's', 'h', ' ', ' ', ' ',
 '1', '.', '0', '0'
};


static const uint8_t UNIT_SERIAL_NUMBER[] = {
 0x00,
 0x80,
 0x00,
 0x03,
 0x00,
 0x00,
 0x00
};


static uint8_t StorageInit();
static uint8_t StorageIsReady();
static uint8_t StorageIsWriteProtected();
static uint8_t StorageGetCapacity(uint32_t* blockNum, uint32_t *blockSize);
static uint8_t StorageRead(uint8_t *buffer, uint32_t lba, uint16_t blockNum);
static uint8_t StorageWrite(uint8_t *buffer, uint32_t lba, uint16_t blockNum);
static uint8_t* StorageGetInquiryData(uint8_t vpd);
static uint8_t* StorageGetStdInquiryData();
static uint8_t* StorageGetModeSenseData();

typedef struct {
 uint8_t(*StorageInit)();
 uint8_t(*StorageIsReady)();
 uint8_t(*StorageIsWriteProtected)();
 uint8_t(*StorageGetCapacity)(uint32_t *blockNum, uint32_t * blockSize);
 uint8_t(*StorageRead) (uint8_t *buffer, uint32_t lba, uint16_t blockNum);
 uint8_t(*StorageWrite)(uint8_t *buffer, uint32_t lba, uint16_t blockNum);
 uint8_t * (*StorageGetInquiryData)(uint8_t vpd);
 uint8_t * (*StorageGetStdInquiryData)();
 uint8_t * (*StorageGetModeSenseData)();
} TMSCStorageCB;

TMSCStorageCB USBDev_MSCStorageCB = {
 StorageInit,
 StorageIsReady,
 StorageIsWriteProtected,
 StorageGetCapacity,
 StorageRead,
 StorageWrite,
 StorageGetInquiryData,
 StorageGetStdInquiryData,
 StorageGetModeSenseData
};









static const uint8_t MMC_OK = 0,
 MMC_ERROR = 255;

static uint8_t GetMmcSectorCount(uint32_t *scCnt)
{
 uint8_t csdbuf[16];
 uint16_t c_size, c_size_mult, mult,
 read_bl_len, block_len;
 uint32_t size, blocknr;


 if (Mmc_Read_Csd(csdbuf) != MMC_OK)
 {
 return MMC_ERROR;
 }


 if (1 == ((csdbuf[0] & 0xC0) >> 6))
 {
 size = 0; size <<= 8;
 size += csdbuf[7] & 0x3F; size <<= 8;
 size += csdbuf[8]; size <<= 8;
 size += csdbuf[9]; size <<= 0;


 size *= 1024;
 }

 else
 {
 c_size = ((csdbuf[8] & 0xC0) >> 6) +
 ((unsigned) csdbuf[7] << 2) +
 (((unsigned) csdbuf[6] & 0x03) << 10);
 c_size_mult = (csdbuf[10] & 0x80) +
 (((unsigned) csdbuf[9] & 0x03) << 8);
 c_size_mult = c_size_mult >> 7;

 read_bl_len = csdbuf[5] & 0x0f;

 mult = 1;
 mult = mult << (c_size_mult + 2);

 blocknr = (c_size + 1) * (long) mult;
 block_len = 1;
 block_len = block_len << read_bl_len;

 size = block_len * blocknr;


 size /= 512;
 }

 *scCnt = size;

 return MMC_OK;
}

static uint8_t storageInitStatus;

static uint8_t StorageInit() {

 storageInitStatus = Mmc_Init();
 return storageInitStatus;
}


static uint8_t StorageGetCapacity(uint32_t* blockNum, uint32_t *blockSize) {
 GetMmcSectorCount(blockNum);
 *blockSize = 512;
 return 0;
}


static uint8_t StorageRead(uint8_t *buffer, uint32_t lba, uint16_t blockNum) {
 uint8_t status;
 status = 0;
 Mmc_Multi_Read_Start(lba);
 while (blockNum) {
 Mmc_Multi_Read_Sector(buffer);
 buffer += 512;
 blockNum--;
 }
 Mmc_Multi_Read_Stop();
 return status;
}


static uint8_t StorageIsReady() {
 if(storageInitStatus)
 return 0;
 else
 return 1;
}


static uint8_t StorageWrite(uint8_t *buffer, uint32_t lba, uint16_t blockNum) {
 uint8_t status;
 status = 0;
 while (blockNum) {
 status |= Mmc_Write_Sector(lba, buffer);
 lba++;
 buffer += 512;
 blockNum--;
 }
 return status;
}


static uint8_t StorageIsWriteProtected() {
 return 0;
}


static uint8_t* StorageGetInquiryData(uint8_t vpd) {
 if(vpd == 0x80)
 return (uint8_t *)UNIT_SERIAL_NUMBER;
}


static uint8_t* StorageGetStdInquiryData() {
 return (uint8_t *)STD_INQUIRY_DATA;
}


static uint8_t* StorageGetModeSenseData() {
 return (uint8_t *)MODE_SENSE_6_DATA;
}
